<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<title>CMS Designer - 動作環境チェックスクリプト</title>
</head>

<body>

<h1>CMS Designer - 動作環境チェックスクリプト 2017.08.31a</h1>

<?php
	/* ======================================================================
	 * (c) AL-Design 2004.12.14
	 * CMS Designer 動作環境チェック用スクリプト
	 * ----------------------------------------------------------------------
	 * 実際のインストール前に、動作環境が動作条件を満たしているかをチェック
	 * します。
	 * サーバ上のどこかにこのファイルを設置して実行してください。
	 * このチェックがOKだったとしても、実際に動作するとは限りませんのでご了承
	 * ください。
	 * ----------------------------------------------------------------------
	 */

	$checkOk = true;

	// 一般APIチェック -----------------------------------------------------
	$functions = array(
		'file_exists',
		'count',
		'unlink',
		'glob',
		'htmlspecialchars',
		'dirname',
		'sprintf',
		'strrpos',
		'substr',
		'is_numeric',
		'move_uploaded_file',
		'is_uploaded_file',
		'fopen',
		'fclose',
		'flock',
		'fgets',
		'fread',
		'fwrite',
		'date',
		'rename',
		'in_array',
		'basename',
		'str_replace',
		'realpath',
		'explode',
		'array_pop',
		'rawurlencode',
		'crypt',
		'time',
		'setcookie',
		'strcmp',
		'array_keys',
		'intval',
		'md5',
		'uniqid',
		'rand',
		'header',
		'readfile',
		'strtolower',
		'filesize',
		'session_start',
		'ob_start',
		'ob_get_contents',
		'ob_end_clean',
		'error_reporting'
	);
	
	if ( ! check_functions_ok( $functions ) )
	{
		$checkOk = false;
	}
	
	// マルチバイト&正規表現関連チェック ------------------------------------
	$functions = array(
		'mb_convert_encoding',
		'mb_detect_encoding',
		'mb_strlen',
		'preg_split',
		'preg_match',
		'preg_split',
		'mb_substr',
		'mb_http_output'
	);
	
	if ( ! check_functions_ok( $functions ) )
	{
		$checkOk = false;
	}
	
	// イメージ関数 --------------------------------------------------------
	$functions = array(
		'getimagesize',
		'imagecreatefromgif',
		'imagecreatefromjpeg',
		'imagecreatefrompng',
		'imagecopyresized',
		'imagegif',
		'imagejpeg',
		'imagepng',
		'imagedestroy'
	);
	
	if ( ! check_functions_ok( $functions ) )
	{
		$checkOk = false;
	}
	
	// PHP5の場合、DOMとXSLTはバンドルされているのでチェック不要
	if ( version_compare(PHP_VERSION,'5','>=') )
	{
		// XSLエクステンションがロードされているか
		if ( ! extension_loaded('xsl') )
		{
			print( "PHPのXSLエクステンション" . "が有効になっていません。サーバ運営会社にお問合せ頂き、XSLエクステンションを有効にする方法をご確認ください。<br />\n" );
			$checkOk = false;
		}
	}
	else {
		
		// DOM API関連チェック -------------------------------------------------
		$functions = array(
			'domxml_open_file',
			'domxml_new_doc',
			'domxml_open_mem'
		);
		
		if ( check_functions_ok( $functions ) )
		{
			// DomDocumentクラスのメソッド
			$xmlDoc = domxml_new_doc( '1.0' );
			
			$functions = array(
				'xpath_new_context',
				'dump_mem',
				'dump_file',
				'dump_node'
			);
			
			if ( check_methods_ok( $xmlDoc, $functions ) )
			{
				// DomNodeクラスのメソッド
				$xmlNode = $xmlDoc->add_root( 'entrynames' );
				$functions = array(
					'unlink_node',
					'set_content',
					'get_content'
				);
				if ( ! check_methods_ok( $xmlDoc, $functions ) )
				{
					$checkOk = false;
				}
				
				// XPATH
				$xpath = $xmlDoc->xpath_new_context();
				$functions = array(
					'xpath_eval'
				);
				if ( ! check_methods_ok( $xpath, $functions ) )
				{
					$checkOk = false;
				}
			}
			else
			{
				$checkOk = false;
			}
			
			
		}
		else
		{
			$checkOk = false;
		}
		
		// XSLT関連チェック ----------------------------------------------------
		if ( function_exists( 'domxml_xslt_stylesheet_file' ) )
		{
			// DOM XSLT API関連チェック
			
		}
		else
		{
			// Sablotron API関連チェック
			$functions = array(
				'xslt_create',
				'xslt_process',
				'xslt_free'
			);
			if ( ! check_functions_ok( $functions ) )
			{
				$checkOk = false;
			}
		}
	}
	
	// ----------------------------------------------------------------------
	print "<br />\n";
	print "----------------------------------------------------------------------<br />\n";
	if ( $checkOk )
	{
		print "CMS Designer動作環境チェック結果は「OK」です。<br />\n但し、これは実際に動作する事を保証するものではありません。<br />\n<a href=\"http://cms.al-design.jp/download.html\" target=\"_blank\">CMS Designer</a>をインストールして実際の動作をご確認ください。<br/>\n";
	}
	else
	{
		print "CMS Designer事前動作チェック結果は「NG」です。<br />\nサーバ管理者又はレンタルサーバ運営者に連絡して、<a href=\"http://cms.al-design.jp/product2.html\" target=\"_blank\">こちらのページ</a>を参考に対応を依頼してください。<br />\n但し、'image'が先頭に付く関数の未サポートについては、画像の拡大/縮小機能を使わなければ問題ありません。<br/>\n";
	}


function check_functions_ok( $functions )
{
	$resultOk = true;
	foreach( $functions as $function )
	{
		if ( !function_exists( $function ) )
		{
			print( $function . "がサポートされていません。<br />\n" );
			$resultOk = false;
		}
	}
	
	return $resultOk;
}

function check_methods_ok( $object, $functions )
{
	$resultOk = true;
	foreach( $functions as $function )
	{
		if ( !method_exists( $object, $function ) )
		{
			print( get_class( $object ) . "->" . $function . "がサポートされていません。<br />\n" );
			$resultOk = false;
		}
	}
	
	return $resultOk;
}


?>
</body>
</html>